#pragma once

template <typename> struct CCallback_;
template <typename F, typename R, typename... Ts>
struct CCallback_<R (F::*) (Ts...) const>
{
    static R invoke(Ts... args, void* u)
    {
        return (*reinterpret_cast<F*>(u))(args...);
    }
};

/// @brief Wrapper for passing closures through C-style callbacks.
/// @tparam F Type of the closure
template <typename F>
using CCallback = CCallback_<decltype(&F::operator())>;
